#include <map>
#include <vector>
#include <string>

using std::map;
using std::string;
using std::vector;

extern void ReadLog(FILE *fp);

struct Instr
{
    int attack, decay, sustain, release;
    int sustainlevel;
    unsigned sampleid;
    
    Instr(): attack(0),decay(0),sustain(0),release(0),
             sustainlevel(0), sampleid(0)
    {
    }
};
struct Sample
{
    unsigned loopbeg, loopend;
    bool looping;
    string data;
};
struct Event
{
    char evtype;
    double time;
    int l, r;            // 'V' volumes event data
    unsigned long freq;  // 'F' freq event data
    unsigned ins;        // 'O' keyon event data
                         // 'K' keyoff event doesn't use data

    Event(char t) : evtype(t),time(0),l(0),r(0),freq(0),ins(0) {}
};
struct Channel
{
    vector<Event> events;
    unsigned lastkeyon;
};

extern map<unsigned, Instr> Instrs;
extern map<unsigned, Sample> Samples;
extern Channel Channels[8];
